<?php
/* 
    Plugin Name: PHP My Profiler Log Analyzer
    Plugin URI: http://www.php-trivandrum.org/open-php-myprofiler/
    Version: 1.00
    Author: Jiju Thomas Mathew <jijutm@saturn.in>
    Author URI: http://www.freelancer.com/u/jthoma.html
    Description: Companion for the PHP My Profiler, shows logs made by wp_php_my_profiler and shows the details where queries went out of hand.
*/

if (!class_exists('wp_php_my_profiler_sampler')):

define( 'WP_PHPMYPROFILER_PATH', plugin_dir_path(__FILE__) );

  class wp_php_my_profiler_sampler
  {
    // Plugin configuration
    public $name;
    
    public $text_domain;

    public $default_options = array(
        'post_type' => 'profiler_log'
    );

    // Singleton
    private static $inst = null;
    
    public static function Instance($new = false)
    {
      if (self::$inst == null || $new)
      {
        self::$inst = new wp_php_my_profiler_sampler();
      }
      return self::$inst;
    }
    
    private function __construct()
    {
      $this->name = strtolower(get_class());
      $this->text_domain = $this->name;
      $this->load_options();
      
      load_plugin_textdomain($this->text_domain, false, dirname(plugin_basename(__FILE__)));
      add_action('admin_menu', array( &$this, 'add_pages'));
    }

    private function load_options()
    {
      foreach($this->default_options as $k => $v)
      {
        $this->default_options[$k] = get_option($this->name . '_' . $k, $v);
      }
    }
    
    public function add_pages()
    {
     $plugin_page = add_menu_page(__("Log Analyzer", $this->text_domain), __("Log Analyzer", $this->text_domain), 'update_plugins', 'log-analyzer', array(&$this, 'logAnalyze'),   plugins_url('phpmyprofiler/analyzer.png'));
    }
    
    public function logAnalyze(){
        global $wpdb;
        if(isset($_REQUEST['action']) && !empty($_REQUEST['action'])){
            // get the file 
            $post_id = (int)$_REQUEST['item'];
            $post = get_post($post_id);
        }
        if('analyze' == $_REQUEST['action']){
            $parser = $post->post_content;
            include WP_PHPMYPROFILER_PATH . "/parser.php";
            return;
        }
        if('delete' == $_REQUEST['action']){
            // delete the log file 
            unlink($post->post_content);
            // delete the database entry
            $wpdb->query("DELETE FROM ". $wpdb->posts . " WHERE ID=" . (int)$_REQUEST['item']);
        }
        require_once(WP_PHPMYPROFILER_PATH . '/profilerListTable.php');
        $listTable = new profilerListTable();
        $listTable->prepare_items($this->default_options['post_type']);

        ?>
        <div class="wrap">
            
            <div class="icon32" style="background-image:url(<?php echo plugins_url( '/analyzer_icon.png', __FILE__ );?>); background-repeat: no-repeat;"><br /></div>
            <h2>Profiler Logs</h2>
            
            <form id="press-releases" method="get">
                <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>" />
                <?php $listTable->display() ?>
            </form>
            
        </div>
      <?php
    
    }
}
  
wp_php_my_profiler_sampler::Instance();
   
endif;

