<?php



class profilerListTable extends WP_List_Table {
    
    function __construct(){
        global $status, $page;
                
        //Set parent defaults
        parent::__construct( array(
            'singular'  => 'profiler_log',     //singular name of the listed records
            'plural'    => 'profiler_logs',    //plural name of the listed records
            'ajax'      => false        //does this table support ajax?
        ) );
        
    }
    
    
    function column_default($item, $column_name){
        return $item[$column_name];
    }
    
    function column_log_title($item){
        //Build row actions
        $actions = array(
            'analyze'      => sprintf('<a href="?page=%s&action=%s&item=%s">Analyze</a>',$_REQUEST['page'],'analyze',$item['ID']),
            'delete'    => sprintf('<a href="?page=%s&action=%s&item=%s" onclick="return confirm(\'Delete this logfile ?\');">Delete</a>',$_REQUEST['page'],'delete',$item['ID']),
        );
        
        //Return the title contents
        return sprintf('%1$s %2$s',
            /*$1%s*/ $item['log_title'],
            /*$2%s*/ $this->row_actions($actions)
        );
    }

    function get_columns(){
        $columns = array(
            'log_title'     => 'Title',
            'log_date'    => 'Date'
         );
        return $columns;
    }
    
    function get_sortable_columns() {
        return array();
    }
    
    function get_bulk_actions() {
        return null;
    }
    
    function process_bulk_action() {
    }
    
    
    function prepare_items($type) {
        global $wpdb; //This is used only if making any database queries

        /**
         * First, lets decide how many records per page to show
         */
        $per_page = get_option('wp_logs_per_page', 20);

        $columns = $this->get_columns();
        $hidden = array();
        $sortable = $this->get_sortable_columns();
        

        $this->_column_headers = array($columns, $hidden, $sortable);

        $this->process_bulk_action();
        
        $current_page = $this->get_pagenum();
        
        $total_items = $wpdb->get_var(sprintf("SELECT count(*) FROM $wpdb->posts WHERE post_type='%s'", $type));
        
        $dataQuery = "SELECT concat('Log starting at ', date_format(post_date,'%H'), ' hours on ', date_format(post_date,'%m/%d/%Y')) as log_title,post_date as log_date, ID FROM $wpdb->posts ".sprintf("WHERE post_type='%s'", $type)." ORDER BY ID ASC LIMIT " . (($current_page-1)*$per_page) . "," . $per_page;

        $data = $wpdb->get_results($dataQuery, 'ARRAY_A');
        
        $this->items = $data;

        $this->set_pagination_args( array(
            'total_items' => $total_items,
            'per_page'    => $per_page,   
            'total_pages' => ceil($total_items/$per_page)  
        ) );
    }
    
}


